SASL
Core

SASL secure transport layer. More...

Collaboration diagram for SASL:

## Typedefs

typedef struct pn_sasl_t | pn_sasl_t
| The SASL layer is responsible for establishing an authenticated and/or encrypted tunnel over which AMQP frames are passed between peers. More...

## Enumerations

enum | pn_sasl_outcome_t { PN_SASL_NONE, PN_SASL_OK, PN_SASL_AUTH, PN_SASL_SYS, PN_SASL_PERM, PN_SASL_TEMP }
| The result of the SASL negotiation. More...

## Functions

pn_sasl_t * | pn_sasl (pn_transport_t *transport)
| Construct an Authentication and Security Layer object. More...
bool | pn_sasl_extended (void)
| Do we support extended SASL negotiation. More...
void | pn_sasl_done (pn_sasl_t *sasl, pn_sasl_outcome_t outcome)
| Set the outcome of SASL negotiation. More...
pn_sasl_outcome_t | pn_sasl_outcome (pn_sasl_t *sasl)
| Retrieve the outcome of SASL negotiation. More...
const char * | pn_sasl_get_user (pn_sasl_t *sasl)
| Retrieve the authenticated user. More...
const char * | pn_sasl_get_mech (pn_sasl_t *sasl)
| Return the selected SASL mechanism. More...
void | pn_sasl_allowed_mechs (pn_sasl_t *sasl, const char *mechs)
| SASL mechanisms that are to be considered for authentication. More...
void | pn_sasl_set_allow_insecure_mechs (pn_sasl_t *sasl, bool insecure)
| Boolean to allow use of clear text authentication mechanisms. More...
bool | pn_sasl_get_allow_insecure_mechs (pn_sasl_t *sasl)
| Return the current value for allow_insecure_mechs. More...
void | pn_sasl_config_name (pn_sasl_t *sasl, const char *name)
| Set the sasl configuration name. More...
void | pn_sasl_config_path (pn_sasl_t *sasl, const char *path)
| Set the sasl configuration path. More...

## Detailed Description

SASL secure transport layer.

## Typedef Documentation

## pn_sasl_t

typedef struct pn_sasl_t pn_sasl_t

The SASL layer is responsible for establishing an authenticated and/or encrypted tunnel over which AMQP frames are passed between peers.

The peer acting as the SASL Client must provide authentication credentials. The peer acting as the SASL Server must provide authentication against the received credentials.

## Enumeration Type Documentation

## pn_sasl_outcome_t

enum pn_sasl_outcome_t

The result of the SASL negotiation.

Enumerator
PN_SASL_OK | negotiation not completed
PN_SASL_AUTH | authentication succeeded
PN_SASL_SYS | failed due to bad credentials
PN_SASL_PERM | failed due to a system error
PN_SASL_TEMP | failed due to unrecoverable error

## Function Documentation

## pn_sasl()

pn_sasl_t* pn_sasl | ( | pn_transport_t * | transport | ) |

Construct an Authentication and Security Layer object.

This will return the SASL layer object for the supplied transport object. If there is currently no SASL layer one will be created.

On the client side of an AMQP connection this will have the effect of ensuring that the AMQP SASL layer is used for that connection.

Returns
  an object representing the SASL layer.

Examples
  broker.c, and direct.c.

## pn_sasl_extended()

bool pn_sasl_extended | ( | void |  | ) |

Do we support extended SASL negotiation.

Do we support extended SASL negotiation? All implementations of Proton support ANONYMOUS and EXTERNAL on both client and server sides and PLAIN on the client side.

Extended SASL implementations use an external library (Cyrus SASL) to support other mechanisms beyond these basic ones.

Returns
  true if we support extended SASL negotiation, false if we only support basic negotiation.

## pn_sasl_done()

void pn_sasl_done | ( | pn_sasl_t * | sasl,
|  | pn_sasl_outcome_t | outcome
| ) |  |

Set the outcome of SASL negotiation.

Used by the server to set the result of the negotiation process.

## pn_sasl_outcome()

pn_sasl_outcome_t pn_sasl_outcome | ( | pn_sasl_t * | sasl | ) |

Retrieve the outcome of SASL negotiation.

## pn_sasl_get_user()

const char* pn_sasl_get_user | ( | pn_sasl_t * | sasl | ) |

Retrieve the authenticated user.

This is usually used at the the server end to find the name of the authenticated user. On the client it will merely return whatever user was passed in to the pn_transport_set_user_password() API.

If pn_sasl_outcome() returns a value other than PN_SASL_OK, then there will be no user to return. The returned value is only reliable after the PN_TRANSPORT_AUTHENTICATED event has been received.

Parameters

  [in] | sasl | the sasl layer

Returns
  If the SASL layer was not negotiated then 0 is returned If the ANONYMOUS mechanism is used then the user will be "anonymous" Otherwise a string containing the user is returned.

## pn_sasl_get_mech()

const char* pn_sasl_get_mech | ( | pn_sasl_t * | sasl | ) |

Return the selected SASL mechanism.

The returned value is only reliable after the PN_TRANSPORT_AUTHENTICATED event has been received.

Parameters

  [in] | sasl | the SASL layer

Returns
  The authentication mechanism selected by the SASL layer

## pn_sasl_allowed_mechs()

void pn_sasl_allowed_mechs | ( | pn_sasl_t * | sasl,
|  | const char * | mechs
| ) |  |

SASL mechanisms that are to be considered for authentication.

This can be used on either the client or the server to restrict the SASL mechanisms that may be used to the mechanisms on the list.

Parameters

  [in] | sasl | the SASL layer
  [in] | mechs | space separated list of mechanisms that are allowed for authentication

Examples
  broker.c, and direct.c.

## pn_sasl_set_allow_insecure_mechs()

void pn_sasl_set_allow_insecure_mechs | ( | pn_sasl_t * | sasl,
|  | bool | insecure
| ) |  |

Boolean to allow use of clear text authentication mechanisms.

By default the SASL layer is configured not to allow mechanisms that disclose the clear text of the password over an unencrypted AMQP connection. This specifically will disallow the use of the PLAIN mechanism without using SSL encryption.

This default is to avoid disclosing password information accidentally over an insecure network.

If you actually wish to use a clear text password unencrypted then you can use this API to set allow_insecure_mechs to true.

Parameters

  [in] | sasl | the SASL layer
  [in] | insecure | set this to true to allow unencrypted PLAIN authentication.

## pn_sasl_get_allow_insecure_mechs()

bool pn_sasl_get_allow_insecure_mechs | ( | pn_sasl_t * | sasl | ) |

Return the current value for allow_insecure_mechs.

Parameters

  [in] | sasl | the SASL layer

## pn_sasl_config_name()

void pn_sasl_config_name | ( | pn_sasl_t * | sasl,
|  | const char * | name
| ) |  |

Set the sasl configuration name.

This is used to construct the SASL configuration filename. In the current implementation it ".conf" is added to the name and the file is looked for in the configuration directory.

If not set it will default to "proton-server" for a sasl server and "proton-client" for a client.

Parameters

  [in] | sasl | the SASL layer
  [in] | name | the configuration name

## pn_sasl_config_path()

void pn_sasl_config_path | ( | pn_sasl_t * | sasl,
|  | const char * | path
| ) |  |

Set the sasl configuration path.

This is used to tell SASL where to look for the configuration file. In the current implementation it can be a colon separated list of directories.

The environment variable PN_SASL_CONFIG_PATH can also be used to set this path, but if both methods are used then this pn_sasl_config_path() will take precedence.

If not set the underlying implementation default will be used. for a client.

Parameters

  [in] | sasl | the SASL layer
  [in] | path | the configuration path